#ifndef APPEDITOR_H
#define APPEDITOR_H

#include "App.h"
#include "Tile.h"
#include "Button.h"
#include "Collide.h"
#include "Brush.h"
#include "dll_shared.h"

#define DM_BLOCKER			4
#define DM_LEFT_GRAB		5
#define DM_RIGHT_GRAB		6
#define DM_POLE				7
#define DM_DROP				8
#define DM_KILL				9
#define DM_BRUSH			10
#define DM_ENTITY			11
#define DM_ENTITY_MOVE		12
#define DM_ENTITY_PATH		13

class CAppEditor : public CApp {
public:
							CAppEditor();
							CAppEditor(string sDir);
	virtual					~CAppEditor();

    virtual CApp*			Run(int dwTime);
    virtual bool			Draw(BITMAP* pBmp);
	virtual CApp*			MouseEvent(unsigned char ucEvent, int dwX, int dwY);

	virtual void			MoveToGrid(int& dwX, int& dwY);

	tileset_p				pvTileSets[64];
	int						dwStartTile;
	int						dwvSelSize[2];
	int						dwDrawMode;
	bool					bvLayerEnable[5];
	BITMAP*					pMainBmp;
	bool					bMouseDown;
	bool					bRMouseDown;
	int						dwTileSetCount;
	int						dwTilePage;
	int						dwvScrollPos[2];

	string					sMapDir;
	tilemap_p				pMap;
	collision_map_p			pColMap;
	tile_brush_p			pBrush;

	CButton*				pvTMode[14];
	CButton*				pvLayer[7];
	CButton*				pvXGrid[3];
	CButton*				pvYGrid[3];
	CButton*				pvEntSel[2];
	CButton*				pEntName;
	CButton*				pvVars[8];

	int						dwvDragPos[2];
	bool					bDragging;
	bool					bRDragging;
	int						dwXGrid;
	int						dwYGrid;

	HMODULE					pDLL;
	dll_edit_exports_p		pDLLInfo;

	map_entity_list_t		svEnts;
	map_entity_p			pSelEnt;
	int						dwEntType;
	int						dwGameTime;

};

#endif // APPEDITOR_H
