#include <allegro.h>
#include <winalleg.h>
#include "AppMapSelect.h"
#include "AppEditor.h"
#include "AppRunner.h"

CApp* cbQuitSelector(CApp* pApp, bool bUp, int dwKey)
{
	return NULL;
}

CApp* cbSelectorUp(CApp* pApp, bool bUp, int dwKey)
{
	if(((CAppMapSelect*)pApp)->dwMap > 0)
		((CAppMapSelect*)pApp)->dwMap--;
	((CAppMapSelect*)pApp)->bRender = true;
	return pApp;
}

CApp* cbSelectorDown(CApp* pApp, bool bUp, int dwKey)
{
	if(((CAppMapSelect*)pApp)->dwMap < ((CAppMapSelect*)pApp)->svMaps.size()-1)
		((CAppMapSelect*)pApp)->dwMap++;
	((CAppMapSelect*)pApp)->bRender = true;
	return pApp;
}

CApp* cbSelectMap(CApp* pApp, bool bUp, int dwKey)
{
	CAppEditor* pEditor = new CAppEditor("Data\\Maps\\"+((CAppMapSelect*)pApp)->svMaps[((CAppMapSelect*)pApp)->dwMap]+"\\");
	((CAppMapSelect*)pApp)->bRender = true;
	return pEditor;
}

CApp* cbNewMap(CApp* pApp, bool bUp, int dwKey)
{
	((CAppMapSelect*)pApp)->bRender = true;

	string sDir = GetString("DirName", "");

	if(sDir.empty())
	{
		while(CGUIEventHandler::GetEvent().dwAll);
		return pApp;
	}

	string sTDir = "Data\\Maps\\"+sDir;
	mkdir(sTDir.c_str());

	sTDir += "\\";
	set_config_file((sTDir+"Map.cfg").c_str());

	string sName = GetString("Name", "");
	set_config_string(NULL, "Name", sName.c_str());
	set_config_string(NULL, "Width", GetString("Width", "").c_str());
	set_config_string(NULL, "Height", GetString("Height", "").c_str());
	set_config_string(NULL, "Tiles", GetString("Tiles", "").c_str());

	set_config_file("");

	((CAppMapSelect*)pApp)->svMaps.push_back(sDir);
	((CAppMapSelect*)pApp)->svNames.push_back(sName);

	while(CGUIEventHandler::GetEvent().dwAll);

	return pApp;
}

CAppMapSelect::CAppMapSelect()
{
	pvKeyFuncs[KEY_ESC] = cbQuitSelector;
	pvKeyFuncs[KEY_UP] = cbSelectorUp;
	pvKeyFuncs[KEY_DOWN] = cbSelectorDown;
	pvKeyFuncs[KEY_ENTER] = cbSelectMap;
	pvKeyFuncs[KEY_N] = cbNewMap;

	bRender = true;
	dwMap = 0;

	al_ffblk sFB;
	if(!al_findfirst("Data\\Maps\\*", &sFB, FA_DIREC))
	{
		do {
			if(sFB.name[0] != '.'  &&  (sFB.attrib&FA_DIREC))
			{
				PACKFILE* pFile = pack_fopen(((string)"Data\\Maps\\"+sFB.name+"\\Map.cfg").c_str(), "r");
				if(pFile)
				{
					pack_fclose(pFile);

					svMaps.push_back(sFB.name);

					set_config_file(((string)"Data\\Maps\\"+sFB.name+"\\Map.cfg").c_str());
					svNames.push_back(get_config_string(NULL, "Name", "Nameless"));
				}
			}
		} while(!al_findnext(&sFB));
		al_findclose(&sFB);
	}
}

CAppMapSelect::~CAppMapSelect()
{
}

CApp* CAppMapSelect::Run(int dwTime)
{
	return this;
}

bool CAppMapSelect::Draw(BITMAP* pBmp)
{
	if(bRender)
	{
		bRender = false;

		clear(pBmp);

		int dwY = (pBmp->h>>1)-svMaps.size()*5;
		for(int lp=0; lp<svMaps.size(); lp++)
		{
			textout_right(pBmp, font, svMaps[lp].c_str(), (pBmp->w>>1)-15, dwY+lp*10, makecol(255, 255, 255));
			textout(pBmp, font, svNames[lp].c_str(), (pBmp->w>>1)+15, dwY+lp*10, makecol(255, 255, 255));
		}

		textout_centre(pBmp, font, "< >", pBmp->w>>1, dwY+dwMap*10, makecol(255, 255, 0));

		return true;
	}

	return false;
}
