#include <allegro.h>
#include <winalleg.h>
#include "AppTiler.h"

CApp* cbQuitTiler(CApp* pApp, bool bUp, int dwKey)
{
	return NULL;
}

CAppTiler::CAppTiler() : CApp()
{
	bShowMouse = true;
	bAutoDelete = false;
	bMouseDown = false;

	pvKeyFuncs[KEY_ENTER] = cbQuitTiler;
}

CAppTiler::~CAppTiler()
{
}

CApp* CAppTiler::Run()
{
	int dwPage = (*pStartTile)>>8;
	if(dwPage < dwTileSetCount  &&  pvTiles[dwPage])
	{
		if(bMouseDown)
		{
			int dwT = (*pStartTile)&0xFF;
			int dwW = (mouse_x>>4)-(dwT%pvTiles[dwPage]->dwWidth)+1;
			int dwH = (mouse_y>>4)-(dwT/pvTiles[dwPage]->dwWidth)+1;
			pSelSize[0] = MAX(1, dwW);
			pSelSize[1] = MAX(1, dwH);
		}
	}

	return this;
}

bool CAppTiler::Draw(BITMAP* pBmp)
{
	clear(pBmp);

	int dwPage = (*pStartTile)>>8;
	if(dwPage < dwTileSetCount  &&  pvTiles[dwPage])
	{
		tileset_p pPage = pvTiles[dwPage];
		blit(pPage->pMainBmp, pBmp, 0, 0, 0, 0, SCREEN_W, SCREEN_H);

		int dwT = (*pStartTile)&0xFF;
		int dwX = (dwT%pPage->dwWidth)<<4;
		int dwY = (dwT/pPage->dwWidth)<<4;

		rect(pBmp, dwX, dwY, dwX+(pSelSize[0]<<4)-1, dwY+(pSelSize[1]<<4)-1, makecol(255, rand()%256, 0));
	}

	return true;
}

CApp* CAppTiler::MouseEvent(unsigned char ucEvent, int dwX, int dwY)
{
	int dwPage = (*pStartTile)>>8;
	if(dwPage < dwTileSetCount  &&  pvTiles[dwPage])
	{
		if(ucEvent == GBE_MOUSE_LEFT_DOWN)
		{
			(*pStartTile) = (dwPage<<8)+(dwX>>4)+(dwY>>4)*pvTiles[dwPage]->dwWidth;
			pSelSize[0] = 1;
			pSelSize[1] = 1;
			bMouseDown = true;
		}
		if(ucEvent == GBE_MOUSE_LEFT_UP)
		{
			bMouseDown = false;
		}
	}

	return this;
}
