#include <allegro.h>
#include <winalleg.h>
#include "Brush.h"
#include <algorithm>

using namespace std;

tile_brush_p CreateBrush()
{
	tile_brush_p pBrush = new tile_brush_t;

	pBrush->dwvSize[0] = 0;
	pBrush->dwvSize[1] = 0;
	pBrush->dwvTiles[0] = NULL;
	pBrush->dwvTiles[1] = NULL;
	pBrush->dwvTiles[2] = NULL;
	pBrush->dwvTiles[3] = NULL;
	pBrush->svColliders.clear();

	return pBrush;
}

void DeleteBrush(tile_brush_p pBrush)
{
	pBrush->svColliders.clear();
	delete pBrush;
}

void AddTilesToBrush(tile_brush_p pBrush, tilemap_p pMap, int dwX, int dwY, int dwW, int dwH, bool bvLayers[])
{
	if(dwX+dwW >= pMap->dwSize[0])
		dwW = pMap->dwSize[0]-dwX-1;
	if(dwY+dwH >= pMap->dwSize[1])
		dwH = pMap->dwSize[1]-dwY-1;

	if(dwX < 0)
	{
		dwW += dwX;
		dwX = 0;
	}
	if(dwY < 0)
	{
		dwH += dwY;
		dwY = 0;
	}

	pBrush->dwvSize[0] = dwW;
	pBrush->dwvSize[1] = dwH;

	int dwS = dwX+dwY*pMap->dwSize[0];
	short* pPos;
	int lx, ly;
	if(bvLayers[0])
	{
		pBrush->dwvTiles[0] = new int[dwW*dwH];
		for(ly=0; ly<dwH; ly++)
		{
			pPos = pMap->pvvLayers[0]+(dwS+(ly<<pMap->dwSize[2]));
			for(lx=0; lx<dwW; lx++)
			{
				(pBrush->dwvTiles[0])[lx+ly*dwW] = *pPos;
				pPos++;
			}
		}
	}
	if(bvLayers[1])
	{
		pBrush->dwvTiles[1] = new int[dwW*dwH];
		for(ly=0; ly<dwH; ly++)
		{
			pPos = pMap->pvvLayers[1]+(dwS+(ly<<pMap->dwSize[2]));
			for(lx=0; lx<dwW; lx++)
			{
				(pBrush->dwvTiles[1])[lx+ly*dwW] = *pPos;
				pPos++;
			}
		}
	}
	if(bvLayers[2])
	{
		pBrush->dwvTiles[2] = new int[dwW*dwH];
		for(ly=0; ly<dwH; ly++)
		{
			pPos = pMap->pvvLayers[2]+(dwS+(ly<<pMap->dwSize[2]));
			for(lx=0; lx<dwW; lx++)
			{
				(pBrush->dwvTiles[2])[lx+ly*dwW] = *pPos;
				pPos++;
			}
		}
	}
	if(bvLayers[3])
	{
		pBrush->dwvTiles[3] = new int[dwW*dwH];
		for(ly=0; ly<dwH; ly++)
		{
			pPos = pMap->pvvLayers[3]+(dwS+(ly<<pMap->dwSize[2]));
			for(lx=0; lx<dwW; lx++)
			{
				(pBrush->dwvTiles[3])[lx+ly*dwW] = *pPos;
				pPos++;
			}
		}
	}
}

void PlaceBrush(tile_brush_p pBrush, tilemap_p pMap, int dwX, int dwY)
{
	int dwW = pBrush->dwvSize[0];
	int dwH = pBrush->dwvSize[1];
	int dwTX = 0;
	int dwTY = 0;

	if(dwX < 0)
	{
		dwTX -= dwX;
		dwW += dwX;
		dwX = 0;
	}
	if(dwY < 0)
	{
		dwTY -= dwY;
		dwH += dwY;
		dwY = 0;
	}
	if(dwX+dwW >= pMap->dwSize[0])
		dwW = pMap->dwSize[0]-dwX-1;
	if(dwY+dwH >= pMap->dwSize[1])
		dwH = pMap->dwSize[1]-dwY-1;

	int dwD;
	if(pBrush->dwvTiles[0])
	{
		for(int lx=0; lx<dwW; lx++)
			for(int ly=0; ly<dwH; ly++)
				if(dwD = (pBrush->dwvTiles[0])[(lx+dwTX)+(ly+dwTY)*pBrush->dwvSize[0]])
					(pMap->pvvLayers[0])[(lx+dwX)+((ly+dwY)<<pMap->dwSize[2])] = dwD;
	}
	if(pBrush->dwvTiles[1])
	{
		for(int lx=0; lx<dwW; lx++)
			for(int ly=0; ly<dwH; ly++)
				if(dwD = (pBrush->dwvTiles[1])[(lx+dwTX)+(ly+dwTY)*pBrush->dwvSize[0]])
					(pMap->pvvLayers[1])[(lx+dwX)+((ly+dwY)<<pMap->dwSize[2])] = dwD;
	}
	if(pBrush->dwvTiles[2])
	{
		for(int lx=0; lx<dwW; lx++)
			for(int ly=0; ly<dwH; ly++)
				if(dwD = (pBrush->dwvTiles[2])[(lx+dwTX)+(ly+dwTY)*pBrush->dwvSize[0]])
					(pMap->pvvLayers[2])[(lx+dwX)+((ly+dwY)<<pMap->dwSize[2])] = dwD;
	}
	if(pBrush->dwvTiles[3])
	{
		for(int lx=0; lx<dwW; lx++)
			for(int ly=0; ly<dwH; ly++)
				if(dwD = (pBrush->dwvTiles[3])[(lx+dwTX)+(ly+dwTY)*pBrush->dwvSize[0]])
					(pMap->pvvLayers[3])[(lx+dwX)+((ly+dwY)<<pMap->dwSize[2])] = dwD;
	}
}
