#include <allegro.h>
#include <winalleg.h>
#include "Button.h"
#include <algorithm>

using namespace std;

CButton::CButton()
{
	dwvSize[0] = dwvSize[1] = dwvSize[2] = dwvSize[3] = 0;
	bPressed = false;
	sLabel = "";
}

CButton::~CButton()
{
}

void CButton::Draw(BITMAP* pBmp)
{
	int dwC1 = makecol(255, 255, 255);
	int dwC2 = makecol(224, 224, 224);
	int dwC3 = makecol(128, 128, 128);
	int dwC4 = makecol(64, 64, 64);
	int dwTX = ((dwvSize[0]+dwvSize[2])>>1)+2;
	int dwTY = ((dwvSize[1]+dwvSize[3])>>1)-(text_height(font)>>1)+1;

	if(bPressed)
	{
		swap(dwC1, dwC4);
		swap(dwC2, dwC3);
		dwTX++;
		dwTY++;
	}

	rectfill(pBmp, dwvSize[0], dwvSize[1], dwvSize[2], dwvSize[3], makecol(192, 192, 192));
	rect(pBmp, dwvSize[0], dwvSize[1], dwvSize[2], dwvSize[3], dwC1);
	rect(pBmp, dwvSize[0]+1, dwvSize[1]+1, dwvSize[2]-1, dwvSize[3]-1, dwC2);
	hline(pBmp, dwvSize[0], dwvSize[3], dwvSize[2], dwC4);
	hline(pBmp, dwvSize[0]+1, dwvSize[3]-1, dwvSize[2]-1, dwC3);
	vline(pBmp, dwvSize[2], dwvSize[1], dwvSize[3], dwC4);
	vline(pBmp, dwvSize[2]-1, dwvSize[1]+1, dwvSize[3]-1, dwC3);

	text_mode(-1);
	textout_centre(pBmp, font, sLabel.c_str(), dwTX, dwTY, makecol(0, 0, 0));
}

bool CButton::CheckMouse(int dwX, int dwY)
{
	if(dwX < dwvSize[0]  ||  dwY < dwvSize[1]  ||  dwX > dwvSize[2]  ||  dwY > dwvSize[3])
		return false;

	return true;
}

void CButton::SetPos(int dwX, int dwY, int dwW, int dwH)
{
	dwvSize[0] = dwX;
	dwvSize[1] = dwY;
	dwvSize[2] = dwX+dwW-1;
	dwvSize[3] = dwY+dwH-1;
}

void CButton::SetState(bool bState)
{
	bPressed = bState;
}

void CButton::SetLabel(string sVal)
{
	sLabel = sVal;
}
